var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, useMemo, useRef } from "react";
import { screenToSVG } from "@liqvid/utils/svg";
import { usePlotStore } from ".";
import { Utils } from "liqvid";
const { dragHelperReact } = Utils.interactivity;
export function AngleControl(props) {
    var _a;
    const { expr } = props;
    const useStore = usePlotStore();
    const theta = (_a = useStore(state => state.vars[expr.name])) !== null && _a !== void 0 ? _a : 0;
    const r = 45;
    const target = useRef();
    const events = useMemo(() => dragHelperReact((e, hit) => {
        const [x, y] = screenToSVG(target.current, hit.x, hit.y);
        useStore.setState(prev => ({
            vars: Object.assign(Object.assign({}, prev.vars), { [expr.name]: Math.atan2(-y, x) })
        }));
    }, e => {
        document.body.classList.add("dragging");
        target.current = e.currentTarget;
    }, e => {
        document.body.classList.remove("dragging");
    }), []);
    return (_jsxs("svg", Object.assign({ className: "vector-control", viewBox: "-50 -50 100 100" }, { children: [_jsx("circle", { className: "track", cx: "0", cy: "0", r: r }, void 0), _jsx(Vector, Object.assign({ className: "draggable", x1: 0, y1: 0, x2: r * Math.cos(theta), y2: -r * Math.sin(theta), tipWidth: 5 }, events), void 0)] }), void 0));
}
const DEGREES = 180 / Math.PI;
const computeD = ({ x1, x2, y1, y2, tipWidth }) => {
    const dx = x2 - x1, dy = y2 - y1, theta = Math.atan2(dy, dx), pythagoras = Math.hypot(dx, dy), angle = 25 * DEGREES;
    return [
        `M ${x2} ${y2}`,
        `l ${tipWidth * Math.cos(theta + Math.PI - angle)} ${tipWidth * Math.sin(theta + Math.PI - angle)}`,
        `L ${x2 + tipWidth * Math.cos(theta + Math.PI + angle)} ${y2 + tipWidth * Math.sin(theta + Math.PI + angle)}`,
        "z"
    ].join(" ");
};
export const Vector = forwardRef(function Vector(_a, ref) {
    var { className = "", x1, x2, y1, y2, a, dx, dy, tipWidth = .125 } = _a, attrs = __rest(_a, ["className", "x1", "x2", "y1", "y2", "a", "dx", "dy", "tipWidth"]);
    const line = useRef();
    const path = useRef();
    if (typeof dx === "number") {
        x2 = x1 + dx;
    }
    if (typeof dy === "number") {
        y2 = y1 + dy;
    }
    const d = computeD({ x1, x2, y1, y2, tipWidth });
    return (_jsxs("g", Object.assign({ className: className, ref: ref }, attrs, { children: [_jsx("line", Object.assign({ ref: line }, { x1, x2, y1, y2 }), void 0), _jsx("path", { ref: path, d: d, fill: attrs.stroke }, void 0)] }), void 0));
});
