import { jsx as _jsx } from "react/jsx-runtime";
import { forwardRef, useEffect } from "react";
import { usePlotStore } from ".";
import { ExpressionPlot } from "./ExpressionPlot";
const defaults = {
    opacity: 1
};
export const Expression = forwardRef(function Expression(props, ref) {
    const useStore = usePlotStore();
    if (!useStore.getState().expressions.find(_ => _.id === props.id)) {
        useStore.setState(state => ({ expressions: state.expressions.concat(Object.assign(Object.assign({}, defaults), props)) }));
    }
    else {
        useStore.getState().updateExpression(props.id, props);
    }
    useEffect(() => {
        return () => {
            useStore.setState(state => ({ expressions: state.expressions.filter(e => e.id !== props.id) }));
        };
    }, []);
    return (_jsx(ExpressionPlot, { id: props.id }, void 0));
});
