import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { KTX } from "rp-katex";
import shallow from "zustand/shallow";
import { Utils } from "liqvid";
const { onClick } = Utils.mobile;
import { usePlotStore } from ".";
import { PlayPause } from "./PlayPause";
import { VarSlider } from "./VarSlider";
import { AngleControl } from "./AngleControl";
export function FormulaList() {
    const useStore = usePlotStore();
    const ids = useStore(state => state.expressions.map(_ => _.id), shallow);
    return (_jsx("ul", Object.assign({ className: "p3d-formulas" }, { children: ids.map(id => (_jsx(Formula, { id: id }, id))) }), void 0));
}
function Formula({ id }) {
    const useStore = usePlotStore();
    const expr = useStore(state => state.expressions.find(_ => _.id === id), shallow);
    if (!expr)
        return null;
    const style = {};
    if (expr.secret)
        style.display = "none";
    return (_jsxs("li", Object.assign({ style: style }, { children: [expr.sliderBounds ?
                _jsx(PlayPause, { id: expr.id, sliderBounds: expr.sliderBounds, v: expr.latex[0] }, void 0) : _jsx("span", { className: "color", style: { backgroundColor: color(expr.color) } }, void 0), expr.latex ? _jsx(KTX, { children: expr.latex }, void 0) : null, expr.sliderBounds && _jsx(VarSlider, { expr: expr }, void 0), typeof expr.angle !== "undefined" && _jsx(AngleControl, { expr: expr }, void 0)] }), void 0));
}
function color(x) {
    if (typeof x === "undefined") {
        return "#FFFFFF";
    }
    return "#" + x.toString(16).padStart(6, "0");
}
function fmt(x) {
    return x.toString().replace(/-/g, "\u2212");
}
