import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useCallback, useMemo, useRef, useState } from "react";
import { Utils } from "liqvid";
const { onClick } = Utils.mobile;
import { usePlotStore } from ".";
const speed = 1000;
export function PlayPause({ id, sliderBounds, v }) {
    return null;
    const [paused, set] = useState(true);
    const useStore = usePlotStore();
    const animating = useRef(false);
    const init = useRef();
    const last = useRef();
    const loop = useCallback((t) => {
        const spread = sliderBounds.max - sliderBounds.min;
        const dt = (t - last.current) / speed % (2 * spread);
        const right = sliderBounds.max - init.current;
        let val;
        if (dt <= right) {
            val = init.current + dt;
        }
        else if (dt >= spread + right) {
            val = sliderBounds.min + (dt - spread - right);
        }
        else {
            val = sliderBounds.max - (dt - right);
        }
        useStore.getState().updateExpression(id, { latex: `${v}=${fmt(val)}` });
        if (animating.current)
            requestAnimationFrame(loop);
    }, []);
    const play = useCallback(() => {
        init.current = useStore.getState().vars[v];
        last.current = performance.now();
        animating.current = true;
        requestAnimationFrame(loop);
        set(false);
    }, []);
    const pause = useCallback(() => {
        animating.current = false;
        set(true);
    }, []);
    const events = useMemo(() => onClick(e => {
        e.preventDefault();
        set(prev => {
            if (prev) {
                play();
            }
            else {
                pause();
            }
            return !prev;
        });
        return false;
    }), []);
    return (_jsx("button", Object.assign({ className: "playpause" }, events, { children: _jsxs("svg", Object.assign({ viewBox: "0 0 36 36" }, { children: [_jsx("circle", { cx: "18", cy: "18", r: "16" }, void 0), paused ?
                    _jsx("path", { d: "M 13,26 19.5,22 19.5,14 13,10 z M 19.5,22 26,18 26,18 19.5,14 z" }, void 0)
                    :
                        _jsx("path", { d: "M 11 26 h 4 v -16 h -4 z M 21 26 h 4 v -16 h -4 z" }, void 0)] }), void 0) }), void 0));
}
function fmt(x) {
    return x.toFixed(2).replace(/-/g, "\u2212").replace(/0+$/g, "");
}
