declare type Fn = (x: number, y: number, z: number) => number;
declare type Vector2 = [number, number];
declare type Vector3 = [number, number, number];
declare type OneForm = (x: number, y: number, z: number) => Vector2;
declare type OneForm3 = (x: number, y: number, z: number) => Vector3;
declare type Matrix2 = [Vector2, Vector2];
export declare function lazyJacobian(f: Fn): OneForm3;
export declare function intersectSurfacesParametric(): void;
export declare function intersectSurfacesImplicit(f: Fn, g: Fn, df: OneForm, dg: OneForm, q0: THREE.Vector3, samples: number, step: number): any[];
export declare function curvePoint(f: Fn, g: Fn, df: OneForm, dg: OneForm, q0: THREE.Vector3): import("three").Vector3;
export declare function solve22Matrix([[a, b], [c, d]]: Matrix2, [y1, y2]: Vector2): number[];
export {};
