import type { State } from "./store";
export declare type Pt2 = [number, number];
export declare type Pt3 = [number, number, number];
export interface IExpression {
    angle?: number;
    color?: number;
    id: string;
    curve?: (t: number, state: State) => Pt3;
    implicit?: (x: number, y: number, z: number, state: State) => number;
    implicitDomain?: {
        min: [number, number, number];
        max: [number, number, number];
        step: [number, number, number];
    };
    parametric?: ConstructorParameters<typeof THREE.ParametricGeometry>[0];
    parametricDomain?: {
        min: [number, number] | number;
        max: [number, number] | number;
    };
    point?: Pt3;
    latex?: string;
    hidden?: boolean;
    lineWidth?: number;
    material?: "basic" | "normal" | "phong" | "toon";
    name?: string;
    oneForm?: (x: number, y: number, z: number, state: State) => Pt3;
    opacity?: number;
    origin?: Pt3 | ((state: State) => Pt3);
    pointSize?: number;
    secret?: boolean;
    sliderBounds?: {
        min: number;
        max: number;
        step: number;
    };
    vars?: string[];
    vector?: Pt3 | ((state: State) => Pt3);
    vectorField?: (x: number, y: number, z: number, state: State) => Pt3;
}
